static char rcsid[] = "@(#)$Id: init.c,v 1.10 2015/04/22 14:53:02 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.10 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI>  (was hurtta+elm@posti.FMI.FI)
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/


#include "def_alias.h"
#include "s_me.h"
#include "save_opts.h"
#include "rc_imp.h"

DEBUG_VAR(Debug,__FILE__,"alias");

#if ANSI_C
#define S_(x) static x;
#else
#define S_(x)
#endif

static char * EDITOR_PROPLINE [] = 
    { "auto", "emacs", "ignore", NULL };
ENUMERATE editor_al_propline = {
    editor_propline_auto,
    NUM_editor_propline,
    &(EDITOR_PROPLINE[0])
};

struct aliases_map     * system_aliases_map;
charset_t                system_aliases_cs;
struct editor_propline * system_aliases_pl;
struct aliases_map     * user_aliases_map;
charset_t                user_aliases_cs;
struct editor_propline * user_aliases_pl;

static ZZZ_SAVE_TYPE alias_info_data[] = {
    {"editor-al-propline",   ZZZ_DT_ENUM(&editor_al_propline), 0 },
};

static int COUNT=(sizeof(alias_info_data)/sizeof(ZZZ_SAVE_TYPE));
static save_info_recs *alias_info = (save_info_recs *) alias_info_data;

S_(dump_conf_map_f dump_user_aliases_file)
static void dump_user_aliases_file P_((FILE *f,const char *actor,
				       char *version_buff));
static void dump_user_aliases_file(f,actor,version_buff) 
     FILE *f;
     const char *actor;
     char *version_buff;
{
    dump_aliases_map(f,user_aliases_map,NULL,actor,version_buff,
		     user_aliases_cs,user_aliases_pl);
}

S_(dump_message_f user_aliases_file_written)
static void user_aliases_file_written P_((char *fname));
static void user_aliases_file_written(fname)
     char *fname;
{

    lib_error(CATGETS(elm_msg_cat, MeSet, 
		      MeAliasesInfoSavedIn,
		      "Aliases info saved in file %s."), 
	      fname);

}




#if ANSI_C
static init_default_hook init_alias_defaults;
#endif
static void init_alias_defaults P_((int *errors));
static void init_alias_defaults(errors)
     int *errors;
{
    system_aliases_map = load_aliases_map(system_aliases_file,errors,
					  &system_aliases_cs,
					  &system_aliases_pl);
    
    register_conf_write(USER_ALIASES_FILE,user_aliases_file,
			dump_user_aliases_file,
			user_aliases_file_written);

}

#if ANSI_C
static init_default_hook alias_read_rc_file;
#endif
static void alias_read_rc_file P_((int *errors));
static void alias_read_rc_file(errors)
     int *errors;
{
    user_aliases_map = load_aliases_map(user_aliases_file,errors,
					&user_aliases_cs,
					&user_aliases_pl);
}

void init_aliaslib()
{
    register_delayed(alias_info,COUNT);
    add_init_default_hook(&init_alias_defaults);
    add_read_rc_file_hook(&alias_read_rc_file);
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
